# frozen_string_literal: true

class UnpublishHousingOfferJob < ActiveJob::Base
 
  queue_as :unpubholow
  unique :until_executed

  def perform(offer_id)

    offer = Hermes::HousingOffer.find_by(id: offer_id)
    if offer && offer.published? && offer.publication_end_date >= Time.zone.now.beginning_of_day
      offer.set(offer_status: 'COMMERCIALISATION NON PUBLIEE', published: false, updated_at: DateTime.current)
    end
  end
end
