
class Hermes::NotificationCenter::HermesMailer < ::ActionMailer::Base
  self.delivery_method = :queued
  default :from => "#{APP_CONFIG["smtp_no_reply"]}" || 'no-reply@plugandwork.fr',
          :return_path => "#{APP_CONFIG["smtp_no_reply"]}" || 'no-reply@plugandwork.fr'
  layout 'hermes_notif'

  def send_notification_email(notification_id)
    @notification      = ::NotificationCenter::Notification.find notification_id
    @notifiable        = @notification.notifiable
    @target            = @notification.targetable
    @mail_template     = @target&.main_user&.default_mail_template || MailTemplate.find_by(default: true) || MailTemplate.new

    notifiable_class   = @notification.notifiable.class.name.split('::').last
    contents           = "::NotificationsCenter::#{notifiable_class}".constantize.new(instance: @notification)

    @full_name         = contents.full_name
    @title             = contents.title
    @body              = contents.body
    @action_link       = "#{HERMES_CONFIG['frontend_url']}#{contents.actions[:link]}"
    @action_title      = contents.actions[:title]

    from = @notification.sender&.email_with_name || "#{APP_CONFIG["smtp_no_reply"]}"

    mail(from: from, to: @target.send(@target.notification_email_field), subject: @title)
  end
end