# frozen_string_literal: true

module Hermes
  # Entity serializer
  class EntityValidationSerializer < Hermes::ApplicationSerializer
    cache key: proc { "#{object.cache_key}" }, expires_in: 1.day
    attributes %i[
      entity_id
      applicant_id
      identification_number
      civility
      first_name
      last_name
      birth_date
      validation
      contract_start_date
      contract_end_date
      active
    ]

    type 'entity_validation'
  end
end
