# frozen_string_literal: true

module Hermes
  class HousingApplicationLightSerializer < Hermes::ApplicationSerializer
    cache key: proc { "#{object.cache_key}" }, expires_in: 1.day
    type 'housing_applications'

    attributes %i[
      applicant_id
      housing_request
      housing_request_id
      housing_offer_id
      effort_rate
      profile_epci_score
      status
      eligible_position
      applicated_position
      score_id
      rank
      als_id
      event_date
    ]

    def housing_request
      {
        als_id: object.als_id
      }
    end

    def applicant_id
      object.applicant_id&.to_s
    end
    
    def housing_request_id
      object.housing_request_id&.to_s
    end
    
    def housing_offer_id
      object.housing_offer_id&.to_s
    end
  end
end
