# frozen_string_literal: true

module Hermes
  # Score serializer
  class ScoreSerializer < Hermes::ApplicationSerializer
    cache key: proc { "#{object.cache_key}" }, expires_in: 1.day
    attributes %i[
      applicant_id
      housing_offer_id
      profile_epci_score
      position_points
      eligible_position
      applicated_position
      detailed_score
    ]

    type 'score'

    def detailed_score
      object&.detailed_score.as_json(
        only: %i[
          _id
          under_30_year_points
          history_points
          entity_points
          effort_rate_points
          motivation_points
          seniority_points
          created_at
        ]
      )
    end
  end
end
