Rails.logger.tagged('HERMES MIGRATIONS') do
  Rails.logger.debug "Start check"
  base_version=File.read(File.join(Rails.root, 'packages', 'hermes', 'VERSION')).gsub(/\s+/, "")
  Dir["#{Rails.root}/packages/hermes/config/migrations/*_#{base_version}.rb"].each do |path|
    if File.file?(path)
      filename=File.basename(path)
      current_version=Gem::Version.new(base_version)
      migration_version=Gem::Version.new(filename.split('_').last.sub(/\.rb$/, ''))
      if !Migration.find_by(filename: "hermes_#{filename}") && (current_version >= migration_version )
        begin
          Rails.logger.debug "launch #{filename}"
          require path
          Migration.create(filename: "hermes_#{filename}")
        rescue StandardError => e
          Rails.logger.debug "error launching #{filename} --- error: #{error.inspect}"
        end
      end
    end
  end
  Rails.logger.debug "End session check"
end