# frozen_string_literal: true

module Hermes
  module Tools
    # Sugar for require methods
    module RequireSugar
      # sugar for requiring hermes lib modules
      def hermes_require(type, *arr)
        arr.each do |required|
          require Hermes::Engine.root.join('lib', 'hermes', type, required).to_s
        end
      end

      def hermes_workers(*arr)
        hermes_require('workers', *arr)
      end

      def hermes_tools(*arr)
        hermes_require('tools', *arr)
      end

      def hermes_errors(*arr)
        hermes_require('errors', *arr)
      end

      def hermes_concerns(type, *arr)
        arr.each do |concern_name|
          require Hermes::Engine.root.join(
            'app',
            type.pluralize,
            'hermes',
            'concerns',
            concern_name
          ).to_s
        end
      end
    end
  end
end

include Hermes::Tools::RequireSugar
